#include "hmg.ch"

#pragma BEGINDUMP
#include <windows.h>

/*
HB_FUNC ( INITHOTKEY )
{
	RegisterHotKey(
	    (HWND) hb_parnl(1 )	, // window to receive hot-key notification
	    hb_parni(4)		, // identifier of hot key
	    hb_parni(2) ,	// key-modifier flags
	    hb_parni(3)		// virtual-key code
	   );
}

HB_FUNC ( RELEASEHOTKEY )
{
	UnregisterHotKey(
		(HWND) hb_parnl(1),	// window associated with hot key
		hb_parni(2)	// identifier of hot key
   );
}
*/

HB_FUNC ( REGISTERHOTKEY )
{
   int iRet =
   RegisterHotKey(
      (HWND) hb_parnl(1)	, // window to receive hot-key notification
      hb_parni(2)		, // identifier of hot key
      hb_parni(3) ,	// key-modifier flags
      hb_parni(4)		// virtual-key code
	   );
   hb_retl(iRet); // Return boolean
}

#pragma ENDDUMP

PROCEDURE Main
   Local hWnd, nID1, nID2, nID3

   DEFINE WINDOW Win_1 AT 157 , 162 WIDTH 550 HEIGHT 350 TITLE "Press F10 and F12 function keys to test" MAIN NOMAXIMIZE NOMINIMIZE
      // On Key F10 of Win_1 Action MsgInfo('Test F10')
      // ON KEY F11 OF Win_1 ACTION MsgInfo('TEST F11') 
      // ON KEY F12 OF Win_1 ACTION MsgInfo('TEST F12') 
   END WINDOW

   /* nID1 := _GetId()
   nID2 := _GetId()
   nID3 := _GetId() */
   nID1 := 320
   nID2 := 321
   nID3 := 322
   hWnd := GetFormHandle("Win_1")

   /*
   MsgInfo(hb_ValToStr(InitHotkey(hWnd, 0, VK_F10, nID1)))
   MsgInfo(hb_ValToStr(InitHotkey(hWnd, 0, VK_F11, nID2)))
   MsgInfo(hb_ValToStr(InitHotkey(hWnd, 0, VK_F12, nID3)))
   */

   MsgInfo("Register hotkey is: " + hb_ValToStr(RegisterHotkey(hWnd, nID1, 0, VK_F10)))
   MsgInfo("Register hotkey is: " + hb_ValToStr(RegisterHotkey(hWnd, nID2, 0, VK_F11)))
   MsgInfo("Register hotkey is: " + hb_ValToStr(RegisterHotkey(hWnd, nID3, 0, VK_F12)))

   InstallEventHandler("HotkeyProc")

   ACTIVATE WINDOW Win_1

   ReleaseHotkey(hWnd, nID1)
   ReleaseHotkey(hWnd, nID2)
   ReleaseHotkey(hWnd, nID3)
Return

Procedure HotkeyProc(hWnd, nMsg, wParam, lParam)
   Local nRet := Nil , WM_HOTKEY := 786

   If nMsg = WM_HOTKEY
      MsgInfo("Hotkey Is Press", "Catch hotkey")
      nRet := 1 // Return non Nil value
   EndIf
Return nRet